<?php
class tx_ccfacebookpublisher_tcemainprocdm 
  {
  	var $pageinfo;
	var $facebook;
	var $TS;
	var $menu;
	var $modulContent;
	var $message;
	var $loginurl;
	
	function processDatamap_postProcessFieldArray ($status, $table, $id, &$fieldArray, &$reference) {
		$this->TS = $this->loadTS('1');
		if ($table == 'tt_news' && $fieldArray['status'] == 0 && $this->getConfig("pushwhensave") == "1") {
			$fbcondition = (array) $reference->datamap['tt_news'][$id]['tx_ccfacebookpublisher_publishtofacebook'];
			$insert = (array) $reference->datamap['tt_news'][$id];
			$notpublish = $this->getStatus($id);
			if($fbcondition[0] == "1" && $notpublish == NULL) {
				$this->getFacebookAPI();
				$this->pushToFacebook($id, $insert);
			}
			
		}
    }
	
	private function getFacebookAPI() {
		require 'mod1/facebook/facebook.php';
		$this->facebook = new Facebook(array(
		  'appId'  =>  $this->getConfig("appID"),
		  'secret' =>  $this->getConfig("appSecret"),
		));
		
	}
	
	/**************************/
	/**** HELPER FUNCTIONS ****/
	/**************************/
	
	/**
	 * Checks for the Facebook auth status
	 * @param		NULL		NULL
	 * @return		bool		true/false
	 */
	private function checkAuth() {
		$user = $this->facebook->getUser();
		
		if ($user) {
		  try {
			// Proceed knowing you have a logged in user who's authenticated.
			$user_profile = $this->facebook->api('/me');
		  } catch (FacebookApiException $e) {
			error_log($e);
			$user = null;
		  }
		}

		// Login or logout url will be needed depending on current user state.
		if ($user) {
		  return true;
		} else {
		  return false;
		
		}
	}
	
	/**
	 * Loads the TS config
	 * @param	$pageUID	int		$pageUID
	 * @return				array 	setup
	 */
	private function loadTS($pageUid) {
        $sysPageObj = t3lib_div::makeInstance('t3lib_pageSelect');
        $rootLine = $sysPageObj->getRootLine($pageUid);
        $TSObj = t3lib_div::makeInstance('t3lib_tsparser_ext');
        $TSObj->tt_track = 0;
        $TSObj->init();
        $TSObj->runThroughTemplates($rootLine);
        $TSObj->generateConfig();
    	return $TSObj->setup;
   	} 

	/**
	 * Pushs the posts to Facebook
	 * @param		NULL	NULL
	 * @return	 	bool	true/false
	 */
	private function pushToFacebook($id, $insert) {
		$pages = $this->getPublishPages();
		// Foreach Post
		$post = $insert;		
		$baseURL = $this->TS['config.']['baseURL'];
		
			foreach($pages as $page) {
				if($page != NULL) {
				
					$insert['link'] = (string)($this->getNewsLink($id));
					if($insert['link'] == $this->TS['config.']['baseURL']) {
						$insert['link'] = $this->TS['config.']['baseURL'].'?id='.$this->getConfig('newspageid').'&tx_ttnews%5Btt_news%5D='.$id;
					}
					
					$insert['name'] = $post['title'];
					$insert['message'] = $post['short'];
					$insert['description'] = $post['short'];
					
					if(!empty($post['image'])) {
						$insert['picture'] = $this->TS['config.']['baseURL']."uploads/pics/".$post['image'];
					}
					elseif($this->getConfig("defaultpic") != NULL) {
						$insert['picture'] = $this->getConfig("defaultpic");
					}
					
					$insert['access_token'] = $this->getConfig('AT-'.$page);
					
							
					 try {
						$this->facebook->api('/'.$page.'/feed/', 'POST',$insert);
						$result = true;
						$this->message = '<div class="alert alert-success">Postet</div>';
						$this->setPublish($id);
					} catch (FacebookApiException $e) {
						$result = false;
						$this->content = '<div class="alert alert-error">Not postet</div>';
						
						error_log($e);
					}
					unset($insert['picture']);
					unset($insert);
					unset($post['image']);
					
				}
			}
		return $result;
	}
	
	/**
	 * Checks if there is an accesstoken from a Facebook page
	 * @param		NULL		NULL
	 * @return		bool		true/false
	 */
	private function getAT() {
		$page = $this->getConfig('pages');
		if(!$page) return false;
		$page = explode(",",$page);
		foreach($page as $id) {
			if($id != NULL) $AT = $this->getConfig("AT-".$id);
		} 
		return $AT?true:false;
	}
	
	/**
	 * returns the Facebook pages and the selected
	 * @param		NULl		NULL
	 * @return		string		HTML options with the Facebook pages
	 */
	private function getFacebookPages() {
		$pages = $this->facebook->api('/me?fields=accounts');
		$content = "";
		//var_dump($pages);
		$pages_fd = explode(",",$this->getConfig("pages"));
		
		foreach($pages['accounts']['data'] as $page) {
			$selected = "";
			foreach($pages_fd as $spage) {
				if($spage == $page['id']) {
					$selected = "selected ";
				}
			}
			$content .= '<option '.$selected.'value="'.$page['id'].'">'.$page['name']."</option>";
			unset($selected);
		}
		return $content;
	}
	
	/**
	 * returns the pages on which we will publish
	 * @param		NULL		NULL
	 * @return 		array 		pages
	 */
	private function getPublishPages() {
		return explode(",",$this->getConfig("pages"));
	}
	
	/**
	 * returns the posts which we will publish
	 * @param		NULL		NULL
	 * @return		array 		posts
	 */
	private function getPosts() {
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*',         	// SELECT ...
			'tt_news',     	// FROM ...
			'tx_ccfacebookpublisher_publishtofacebook="1" AND tx_ccfacebookpublisher_allreadypublished IS NULL '.
			'AND hidden = 0 AND deleted = 0 AND starttime <= UNIX_TIMESTAMP() AND (endtime = 0 OR endtime > UNIX_TIMESTAMP()) ',    // WHERE...
			'',            	// GROUP BY...
			'',    			// ORDER BY...
			''            	// LIMIT to 10 rows, starting with number 5 (MySQL compat.)
		);
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			$data[] = $row;
		}
		return $data;
	}
	
	/**
	 * get the news categorys and their realURL link
	 * @param	$newsUID	int		UID
	 * @param		string		realURL string
	 */
	private function getNewsCatPage($newsUID) {
		$what = "*";
        $table = "tx_realurl_urlencodecache";
        $where = 'origparams LIKE "%ttnews%5Btt_news%5D='.$newsUID.'%"';
        $groupBy      = '';
        $orderBy      = '';
        $limit        = '1';
        $recordList = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows($what,$table,$where,$groupBy,$orderBy,$limit);
        if (!is_array($recordList)) return 0;
        
        $cat = $recordList[0]['content'];
		return $cat;
        
    }
	
	/**
	 * get the complete link of the post
	 * @param 	$uid	int 	newsuid
	 * @return 			string	link
	 */
	private function getNewsLink($uid) {
		return ($this->TS['config.']['baseURL'].$this->getNewsCatPage($uid));
	}
		
	/**
	 * get the complete link of the post
	 * @param 	$uid	int 	post
	 * @return 			bool	true/false
	 */	
	private function setPublish($uid) {
		$updateArray = array(
			'tx_ccfacebookpublisher_allreadypublished' => "1"
		);
		$res = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('tt_news', 'uid='.$uid, $updateArray);
	}
	
	/**
	 * set a config variable
	 * @param	$key	string	keyname
	 * @param	$value	string	value of the config
	 * @return			bool	true/false
	 */
	private function setConfig($key, $value) {
		$GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey = "'.$key.'"');
		$insertArray = array(
			'configkey' => $key,
			'value' => $value
		);
		$res = $GLOBALS['TYPO3_DB']->exec_INSERTquery('tx_ccfacebookpublisher_config', $insertArray);
	}
	
	/**
	 * removes the pages from the config
	 * @param			NULL	NULL
	 * @return			bool	true/false
	 */
	private function removePages() {
		$res = $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey LIKE "AT-%"');
		return $res = $GLOBALS['TYPO3_DB']->exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey="pages"');
	}
	
	/**
	 * get a config variable
	 * @param	$key	string	Keyname
	 * @return 			string	value
	 */
	private function getConfig($key) {
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*',         		// SELECT ...
			'tx_ccfacebookpublisher_config',     // FROM ...
			'configkey="'.$key.'"',    // WHERE...
			'',            		// GROUP BY...
			'',    				// ORDER BY...
			'1'            		// LIMIT
		);
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			return $row['value'];
		}
	}
	
	private function getStatus($id) {
		$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
			'*',         		// SELECT ...
			'tt_news',     		// FROM ...
			'uid="'.$id.'"',    // WHERE...
			'',            		// GROUP BY...
			'',    				// ORDER BY...
			'1'            		// LIMIT to 10 rows, starting with number 5 (MySQL compat.)
		);
		while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
			return $row['tx_ccfacebookpublisher_allreadypublished'];
		}
	}
	
	/** STYLING AND STYLE HELPER **/
	private function getMenu() {
		$content .= '<ul id="myTab" class="nav nav-tabs">';
		foreach($this->menu as $menu) {
			$content .= '<li class="'.$menu["active"].'"><a href="#'.$menu['name'].'" data-toggle="tab">'.$menu["displayname"].'</a></li>';	
		}
		$content .= '</ul>';
        return $content;
	}
	/**
	 * Checks the Facebook permission
	 * @return		bool	true/false
	 */
	private function checkPermission() {
		$user = $this->loginurl;
		if ($user) {
		  try {
			$user_profile = $this->facebook->api('/me');
		  } catch (FacebookApiException $e) {
			error_log($e);
			$user = null;
		  }
		}
		if ($user) {
		  $status = true;
		} else {
		  $status = false;
		}
		return $status;
	}	
	
  }
?>