<?php
/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 Marc Horst <mho@coelnconcept.de>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * [CLASS/FUNCTION INDEX of SCRIPT]
 *
 * Hint: use extdeveval to insert/update function index above.
 */

$LANG -> includeLLFile('EXT:cc_facebook_publisher/mod1/locallang.xml');
require_once (PATH_t3lib . 'class.t3lib_scbase.php');
$BE_USER -> modAccess($MCONF, 1);
// This checks permissions and exits if the users has no permission for entry.
// DEFAULT initialization of a module [END]

/**
 * Module 'Facebook publish configurations' for the 'cc_facebook_publisher' extension.
 *
 * @author	Marc Horst <mho@coelnconcept.de>
 * @package	TYPO3
 * @subpackage	tx_ccfacebookpublisher
 */
class tx_ccfacebookpublisher_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $facebook;
	var $TS;
	var $menu;
	var $modulContent;
	var $message;
	var $loginurl;

	public function init() {
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;

		require 'facebook/facebook.php';

		$this -> facebook = new Facebook( array('appId' => $this -> getConfig("appID"), 'secret' => $this -> getConfig("appSecret"), ));
		$this -> TS = $this -> loadTS('1');
		parent::init();
	}

	public function main() {
		global $BE_USER, $LANG, $BACK_PATH, $TCA_DESCR, $TCA, $CLIENT, $TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this -> pageinfo = t3lib_BEfunc::readPageAccess($this -> id, $this -> perms_clause);
		$access = is_array($this -> pageinfo) ? 1 : 0;
		$this -> loginurl = $this -> facebook -> getLoginUrl(array('scope' => 'publish_stream, manage_pages', 'redirect_uri' => 'http://' . $_SERVER['HTTP_HOST'] . '/'));

		if (($this -> id && $access) || ($BE_USER -> user['admin'] && !$this -> id)) {
			// Draw the header.
			$this -> doc = t3lib_div::makeInstance('mediumDoc');
			$this -> doc -> backPath = $BACK_PATH;
			$this -> content .= '<meta http-equiv="X-UA-Compatible" content="IE=9"/>';
			$this -> content .= $this -> includeBootstrapStyle();
			$this -> content .= $this -> message;
			$this -> modulContent .= '<div class="tab-content">';
			// SET Updates
			$this -> setUpdates();

			// Render content:

			// App Settings Block
			$this -> getTabStart('generalconfig', $LANG -> getLL('fbdetails'));
			$this -> modulContent .= $this -> appSettings();
			$this -> modulContent .= $this -> isAuth();

			$this -> getTabStop();

			// Split Authenticate and Configurations $this->checkAuth()

			if ($this -> getAT()) {
				$this -> getTabStart('pageconfig', $LANG -> getLL('fbselectpage'));
				// Config block
				$this -> modulContent .= $this -> moduleContent();
				$this -> getTabStop();

				$this -> getTabStart('genconf', $LANG -> getLL('genconfig'));
				$this -> modulContent .= $this -> generalConfig();
				$this -> getTabStop();

				$this -> getTabStart('publish', $LANG -> getLL('label_pushtofb'), 'active');
				// Publish content block

				$this -> modulContent .= $this -> publishContent();
				$this -> modulContent .= $this -> postInQueue();
				$this -> getTabStop();

			} else {
				// Auth block
				if ($this -> checkAuth()) {
					$this -> getTabStart('pageconfig', $LANG -> getLL('fbselectpage'));
					// Config block
					$this -> modulContent .= $this -> moduleContent();
					$this -> getTabStop();
				}
			}

			/* DEBUG
			 $this->content.="<br /><br />".'GET:'.t3lib_div::view_array($_GET).'<br />'.
			 'POST:'.t3lib_div::view_array($_POST).'<br />'.
			 '';
			 */
			 
			// ShortCut
			if ($BE_USER -> mayMakeShortcut()) {
				$this -> content .= $this -> doc -> spacer(20) . $this -> doc -> section('', $this -> doc -> makeShortcutIcon('id', implode(',', array_keys($this -> MOD_MENU)), $this -> MCONF['name']));
			}

			$this -> content .= $this -> getMenu();

			$this -> content .= $this -> modulContent;

			$this -> content .= "</div><script>
			  $(function () {
			    $('#myTab a:last').tab('show');
			  })
			</script><div class='layer' style='display: none;'>Bitte warten...</div>";
		} else {

			// If no access or if ID == zero
			$this -> doc = t3lib_div::makeInstance('mediumDoc');
			$this -> doc -> backPath = $BACK_PATH;

			$this -> content .= $this -> doc -> startPage($LANG -> getLL('title'));
			$this -> content .= $this -> doc -> header($LANG -> getLL('title'));
			$this -> content .= $this -> doc -> spacer(5);
			$this -> content .= $this -> doc -> spacer(10);
		}

	}

	/**
	 *	Checks for FB Authentication 
	 *
	 * @param		NULL		NULL
	 * @return	 	string		Login url Button with header
	 */
	private function isAuth() {
		$user = $this -> facebook -> getUser();
		if ($user) {
			try {
				// Proceed knowing you have a logged in user who's authenticated.
				$user_profile = $this -> facebook -> api('/me');
			} catch (FacebookApiException $e) {
				error_log($e);
				$user = null;
			}
		}
		// Login or logout url will be needed depending on current user state.
		if ($user) {
			//$content = '<a target="content" href="'.$this->facebook->getLogoutUrl().'" >Logout</a>';
		} else {
			$content = '<h4>Get the App</h4><fieldset><a target="_blank" class="btn" href="' . $this -> loginurl . '" >Click here to authenticate Facebook</a></fieldset>';
		}
		return $content;
	}

	/**
	 * HTML return for the app settings
	 * @param		NULL		NULL
	 * @return 		string		HTML Layout app settings
	 */
	private function appSettings() {
		global $LANG;
		$content = '<h4>' . $LANG -> getLL('fbdetails') . '</h4>
		<form action="" method="post" enctype="multipart/form-data" class="">
		<fieldset>
		  <div class="control-group">
			<label class="control-label" for="appid">App ID</label>
			<div class="controls">
			  <input type="text" id="appid" value="' . $this -> getConfig('appid') . '" name="appid" class="input" placeholder="appid">
			</div>
		  </div>
		  <div class="control-group">
			<label class="control-label" for="appsecret">App Secret</label>
			<div class="controls">
			  <input value="' . $this -> getConfig('appsecret') . '" type="text" id="appsecret" name="appsecret" placeholder="appsecret">
			</div>
		  </div>
		  <div class="control-group">
			<div class="controls">
			  <input class="btn" type="submit" value="speichern"></input>
			</div>
		  </div>
		  </fieldset>
		</form>';
		return $content;
	}

	/**
	 * HTML return for the selection of the Facebook pages
	 * @param		NULL		NULL
	 * @return		string		HTML Layout Facebook page selection
	 */
	private function moduleContent() {
		global $LANG;
		if ($this -> checkAuth()) {

			$content .= '<h4>' . $LANG -> getLL('fbselectpage') . '</h4><form action="" method="post" enctype="multipart/form-data">
			<fieldset>
			<select multiple name="page[]">
			' . $this -> getFacebookPages() . '
			</select><br /><input class="btn" value="' . $LANG -> getLL('valuesave') . '" type="submit"></input>
			</fieldset>
			</form>';
		} else {
			$content = '<h4>Get the App</h4><fieldset><a target="_blank" class="btn" href="' . $this -> loginurl . '" >Click here to authenticate Facebook</a></fieldset>';
			$content .= "<br />Um die Seiten auszuwählen musst du dich zuerst einloggen!";
		}
		return $content;
	}

	/**
	 * HTML return to publish posts to Facebook
	 * @param:		NULL		NULL
	 * @return:		string		HTML Layout to publish posts to Facebook
	 */
	private function publishContent() {
		global $LANG;
		if (!empty($_POST['makePublish'])) {
			$result = $this -> pushToFacebook();
		}
		$content = '
		<h4>' . $LANG -> getLL('publishfb') . '</h4>
			<form action="" method="post" enctype="multipart/form-data">
				<fieldset>
					<label>' . $LANG -> getLL('label_pushtofb') . '</label>
					<input type="hidden" name="makePublish" value="true"></input>
					<input type="submit" id="pubfacebook" class="btn" value="' . $LANG -> getLL('valuepublish') . '"></input>
				</fieldset>
			</form>
		';
		return $content;
	}

	/**
	 * HTML return shows posts which are waiting in the queue
	 * @param 		NULL		NUll
	 * @return		string		HTML Layout with topics of the posts
	 */
	private function postInQueue() {
		global $LANG;
		$content = '<h4>' . $LANG -> getLL('postsinqueue') . '</h4>';
		$posts = $this -> getPosts();

		$content .= "<div class='fieldset'><ul>";
		foreach ($posts as $single) {
			$content .= "<li>" . $single['title'] . "</li>";
		}
		$content .= "</ul></div>";
		return $content;
	}

	/**
	 * HTML return general config
	 * @param 		NULL		NULL
	 * @return		string		HTML Layout with the general config
	 */
	private function generalConfig() {
		global $LANG;
		$content = '
		<h4>' . $LANG -> getLL('genconfig') . '</h4>
			<form action="" method="post" enctype="multipart/form-data">
				<fieldset>
					<label>' . $LANG -> getLL('defaultpic') . '</label>
					<input type="text" name="defaultpic" value="' . $this -> getConfig("defaultpic") . '"></input>
					<br />
					<label>' . $LANG -> getLL('newspageid') . '</label>
					<input type="text" name="newspageid" value="' . $this -> getConfig("newspageid") . '"></input>
					<br />
					<label>' . $LANG -> getLL('pushtofacebookwhensave') . '</label>
					<select name="pushwhensave">
					<option';
					if ($this -> getConfig("pushwhensave") == 1) {
						$content .= ' selected="selected" ';
					}
					$content .= ' value="1">' . $LANG -> getLL('yes') . '</option>
								<option';
					if ($this -> getConfig("pushwhensave") == 0 || $this -> getConfig("pushwhensave") == NULL) {
						$content .= ' selected="selected" ';
					}
					$content .= ' value="0">' . $LANG -> getLL('no') . '</option>
					</select>
					<br />
					<input type="submit" id="pubfacebook" class="btn" value="' . $LANG -> getLL('valuesave') . '"></input>
				</fieldset>
			</form>
		
		';
		return $content;
	}

	/**
	 * makes the updates which are made in the previous functions
	 * @param		POST 		variables
	 * @return		bool		true
	 */
	private function setUpdates() {
		global $LANG;
		// APP SETTINGS
		if (!empty($_POST['appsecret']) || !empty($_POST['appid']) || (!empty($_POST['appid']) && !empty($_POST['appsecret']))) {
			if (isset($_POST['appsecret'])) {
				$this -> setConfig("appsecret", $_POST['appsecret']);
			} else {
				$this -> setConfig("appsecret", "");
			}

			if (isset($_POST['appid'])) {
				$this -> setConfig("appid", $_POST['appid']);
			} else {
				$this -> setConfig("appid", "");
			}

		}

		// PAGES
		if (!empty($_POST['page'])) {
			if (isset($_POST['page'])) {
				foreach ($_POST['page'] as $page) {
					$sites .= $page . ",";
					$at = $this -> facebook -> api("/me?fields=accounts.fields(id,access_token)");
					foreach ($at['accounts']['data'] as $a) {
						if ($a['id'] == $page) {
							$atoken = $a['access_token'];
						}
					}

					$this -> setConfig("AT-" . $page, $atoken);
				}
				$this -> setConfig("pages", $sites);
			} else {
				$this -> removePages();
			}
		}

		// GENERAL
		if (!empty($_POST['defaultpic'])) {
			$this -> setConfig("defaultpic", $_POST['defaultpic']);
		}

		if (!empty($_POST['newspageid'])) {
			$this -> setConfig("newspageid", $_POST['newspageid']);
		}

		if (!empty($_POST['pushwhensave'])) {
			$this -> setConfig("pushwhensave", $_POST['pushwhensave']);
		}
		
		return true;
	}

	/**************************/
	/**** HELPER FUNCTIONS ****/
	/**************************/
	
	/**
	 * Checks for the Facebook auth status
	 * @param		NULL		NULL
	 * @return		bool		true/false
	 */
	private function checkAuth() {
		$user = $this -> facebook -> getUser();

		if ($user) {
			try {
				// Proceed knowing you have a logged in user who's authenticated.
				$user_profile = $this -> facebook -> api('/me');
			} catch (FacebookApiException $e) {
				error_log($e);
				$user = null;
			}
		}

		// Login or logout url will be needed depending on current user state.
		if ($user) {
			return true;
		} else {
			return false;

		}
	}

	/**
	 * Loads the TS config
	 * @param	$pageUID	int		$pageUID
	 * @return				array 	setup
	 */
	private function loadTS($pageUid) {
		$sysPageObj = t3lib_div::makeInstance('t3lib_pageSelect');
		$rootLine = $sysPageObj -> getRootLine($pageUid);
		$TSObj = t3lib_div::makeInstance('t3lib_tsparser_ext');
		$TSObj -> tt_track = 0;
		$TSObj -> init();
		$TSObj -> runThroughTemplates($rootLine);
		$TSObj -> generateConfig();
		return $TSObj -> setup;
	}

	/**
	 * Pushs the posts to Facebook
	 * @param		NULL	NULL
	 * @return	 	bool	true/false
	 */
	private function pushToFacebook() {
		$posts = $this -> getPosts();
		$pages = $this -> getPublishPages();
		// Foreach Post
		$accounts = array();

		$baseURL = $this -> TS['config.']['baseURL'];

		foreach ($posts as $post) {
			// In each post for each Page
			$this -> message = '<div class="alert alert-error">Nothing to do (getLL)</div>';
			foreach ($pages as $page) {
				if ($page != NULL) {
					//Loop through the array off accounts to find the page with a matching ID to the one we need
					/*	foreach($accounts['data'] as $account){
					 if($account['id'] == $page){
					 $ACCESS_TOKEN = $account['access_token'];
					 }
					 }
					 */
					$insert['link'] = (string)($this -> getNewsLink($post['uid']));

					if ($insert['link'] == $this -> TS['config.']['baseURL']) {
						$insert['link'] = $this -> TS['config.']['baseURL'] . '?id=' . $this -> getConfig('newspageid') . '&tx_ttnews%5Btt_news%5D=' . $post['uid'];
					}

					$insert['name'] = $post['title'];
					$insert['message'] = $post['short'];
					$insert['description'] = $post['short'];

					if (!empty($post['image'])) {
						$insert['picture'] = $this -> TS['config.']['baseURL'] . "uploads/pics/" . $post['image'];
					} elseif ($this -> getConfig("defaultpic") != NULL) {
						$insert['picture'] = $this -> getConfig("defaultpic");
					}

					$insert['access_token'] = $this -> getConfig('AT-' . $page);

					try {
						$this -> facebook -> api('/' . $page . '/feed/', 'POST', $insert);
						$result = true;
						$this -> message = '<div class="alert alert-success">Postet</div>';
					} catch (FacebookApiException $e) {
						$result = false;
						$this -> content = '<div class="alert alert-error">Not postet</div>';

						error_log($e);
					}
					
					unset($insert['picture']);
					unset($insert);
					unset($post['image']);

				}
			}
			$this -> setPublish($post['uid']);
		}

		return $result;
	}

	/**
	 * Checks if there is an accesstoken from a Facebook page
	 * @param		NULL		NULL
	 * @return		bool		true/false
	 */
	private function getAT() {
		$page = $this -> getConfig('pages');

		if (!$page)
			return false;
		$page = explode(",", $page);

		foreach ($page as $id) {
			if ($id != NULL)
				$AT = $this -> getConfig("AT-" . $id);
		}

		return $AT ? true : false;
	}

	/**
	 * returns the Facebook pages and the selected
	 * @param		NULl		NULL
	 * @return		string		HTML options with the Facebook pages
	 */
	private function getFacebookPages() {
		$pages = $this -> facebook -> api('/me?fields=accounts');
		$content = "";
		//var_dump($pages);
		$pages_fd = explode(",", $this -> getConfig("pages"));

		foreach ($pages['accounts']['data'] as $page) {
			$selected = "";
			foreach ($pages_fd as $spage) {
				if ($spage == $page['id']) {
					$selected = "selected ";
				}
			}
			$content .= '<option ' . $selected . 'value="' . $page['id'] . '">' . $page['name'] . "</option>";
			unset($selected);
		}
		return $content;
	}

	/**
	 * returns the pages on which we will publish
	 * @param		NULL		NULL
	 * @return 		array 		pages
	 */
	private function getPublishPages() {
		return explode(",", $this -> getConfig("pages"));
	}

	/**
	 * returns the posts which we will publish
	 * @param		NULL		NULL
	 * @return		array 		posts
	 */
	private function getPosts() {
		$res = $GLOBALS['TYPO3_DB'] -> exec_SELECTquery('*', // SELECT ...
		'tt_news', // FROM ...
		'tx_ccfacebookpublisher_publishtofacebook="1" AND tx_ccfacebookpublisher_allreadypublished IS NULL ' . 'AND hidden = 0 AND deleted = 0 AND starttime <= UNIX_TIMESTAMP() AND (endtime = 0 OR endtime > UNIX_TIMESTAMP()) ', // WHERE...
		'', // GROUP BY...
		'', // ORDER BY...
		'' // LIMIT to 10 rows, starting with number 5 (MySQL compat.)
		);
		while ($row = $GLOBALS['TYPO3_DB'] -> sql_fetch_assoc($res)) {
			$data[] = $row;
		}
		return $data;
	}

	/**
	 * get the news categorys and their realURL link
	 * @param	$newsUID	int		UID
	 * @param		string		realURL string
	 */
	private function getNewsCatPage($newsUID) {
		$what = "*";
		$table = "tx_realurl_urlencodecache";
		$where = 'origparams LIKE "%ttnews%5Btt_news%5D=' . $newsUID . '%"';
		$groupBy = '';
		$orderBy = '';
		$limit = '1';
		$recordList = $GLOBALS['TYPO3_DB'] -> exec_SELECTgetRows($what, $table, $where, $groupBy, $orderBy, $limit);
		if (!is_array($recordList))
			return 0;

		$cat = $recordList[0]['content'];
		return $cat;

	}

	/**
	 * get the complete link of the post
	 * @param 	$uid	int 	newsuid
	 * @return 			string	link
	 */
	private function getNewsLink($uid) {
		return ($this -> TS['config.']['baseURL'] . $this -> getNewsCatPage($uid));
	}

	/**
	 * get the complete link of the post
	 * @param 	$uid	int 	post
	 * @return 			bool	true/false
	 */
	private function setPublish($uid) {
		$updateArray = array('tx_ccfacebookpublisher_allreadypublished' => "1");
		$res = $GLOBALS['TYPO3_DB'] -> exec_UPDATEquery('tt_news', 'uid=' . $uid, $updateArray);
		return $res?true:false;
	}

	/**
	 * set a config variable
	 * @param	$key	string	keyname
	 * @param	$value	string	value of the config
	 * @return			bool	true/false
	 */
	private function setConfig($key, $value) {
		$GLOBALS['TYPO3_DB'] -> exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey = "' . $key . '"');
		$insertArray = array('configkey' => $key, 'value' => $value);
		$res = $GLOBALS['TYPO3_DB'] -> exec_INSERTquery('tx_ccfacebookpublisher_config', $insertArray);
		return $res?true:false;
	}

	/**
	 * removes the pages from the config
	 * @param			NULL	NULL
	 * @return			bool	true/false
	 */
	private function removePages() {
		$res = $GLOBALS['TYPO3_DB'] -> exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey LIKE "AT-%"');
		$res = $GLOBALS['TYPO3_DB'] -> exec_DELETEquery('tx_ccfacebookpublisher_config', 'configkey="pages"');
		return $res?true:false;
	}

	/**
	 * get a config variable
	 * @param	$key	string	Keyname
	 * @return 			string	value
	 */
	private function getConfig($key) {
		$res = $GLOBALS['TYPO3_DB'] -> exec_SELECTquery('*', // SELECT ...
		'tx_ccfacebookpublisher_config', // FROM ...
		'configkey="' . $key . '"', // WHERE...
		'', // GROUP BY...
		'', // ORDER BY...
		'1' // LIMIT to 10 rows, starting with number 5 (MySQL compat.)
		);
		while ($row = $GLOBALS['TYPO3_DB'] -> sql_fetch_assoc($res)) {
			return $row['value'];
		}
	}

	/******************************/
	/** STYLING AND STYLE HELPER **/
	/******************************/
	
	/**
	 * get the HTML menu
	 * @param			NULL	NULL
	 * @return			string	HTML menu
	 */
	private function getMenu() {
		$content .= '<ul id="myTab" class="nav nav-tabs">';
		foreach ($this->menu as $menu) {
			$content .= '<li class="' . $menu["active"] . '"><a href="#' . $menu['name'] . '" data-toggle="tab">' . $menu["displayname"] . '</a></li>';
		}
		$content .= '</ul>';
		return $content;
	}
	
	/**
	 *  returns the style information
	 * @param			NULL	NULL
	 * @return			string	style
	 */
	private function includeBootstrapStyle() {
		return '
		<script src="http://code.jquery.com/jquery-1.10.0.min.js"></script>
		<script src="//netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
			<link rel="stylesheet" type="text/css" href="../typo3conf/ext/cc_facebook_publisher/mod1/bootstrap/css/bootstrap.css" media="all">
			<style>
			fieldset, .fieldset {
				border: 1px solid #C7D7FF !important;
				padding: 10px !important;
				background: #f9f9f9 !important;
				border-radius: 5px;
			}
			select {
				width: auto !important;
			}
			.layer {
				width: 100%;
				height: 50%;
				background: rgba(255, 255, 255, 0.54);
				position: absolute;
				z-index: 9999;
				text-align: center;
				padding-top: 25%;
				font-weight: bold;
				top: 0;
			}
			</style>
			<script>
				$().ready(function(){
					$("#pubfacebook").on("click", function(){
						$(".layer").fadeIn();
					})
				})
			</script>
			
			';
	}

	/**
	 * returns HTML start of one tab
	 */
	private function getTabStart($name, $displayname, $active = "") {
		$this -> menu[] = array("name" => $name, "displayname" => $displayname, "active" => $active);
		$this -> modulContent .= '<div class="tab-pane ' . $active . '" id="' . $name . '">';
	}

	/**
	 * returns HTML stop of one tab
	 */
	private function getTabStop() {
		$this -> modulContent .= "</div>";
	}

	/**
	 * Checks the Facebook permission
	 * @return		bool	true/false
	 */
	private function checkPermission() {
		$user = $this -> loginurl;
		if ($user) {
			try {
				$user_profile = $this -> facebook -> api('/me');
			} catch (FacebookApiException $e) {
				error_log($e);
				$user = null;
			}
		}
		if ($user) {
			$status = true;
		} else {
			$status = false;
		}
		return $status;
	}

	/**
	 * print the content with echo
	 */
	public function printContent() {
		$this -> content .= $this -> doc -> endPage();
		echo $this -> content;
	}

}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cc_facebook_publisher/mod1/index.php']) {
	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/cc_facebook_publisher/mod1/index.php']);
}

// Make instance:
$SOBE = t3lib_div::makeInstance('tx_ccfacebookpublisher_module1');
$SOBE -> init();

// Include files?
foreach ($SOBE->include_once as $INC_FILE)
	include_once ($INC_FILE);

$SOBE -> main();
$SOBE -> printContent();
?>